unit volasms1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP, GTNVolaSMS;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    VSms: TVolaSMS;
    SmsList: TListBox;
    usr: TEdit;
    pwd: TEdit;
    Label3: TLabel;
    dest: TEdit;
    Label4: TLabel;
    msg: TEdit;
    Button2: TButton;
    Button3: TButton;
    Credito: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  VSms: TVolaSMS;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
   VSms := TVolaSMS.create(Self);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    VSms.free;
end;


procedure TForm1.Button1Click(Sender: TObject);
Var
 CmdResponse: TSmsResponse;
 Sms: TSms;
begin
    Vsms.VolaUser:=usr.Text;
    Vsms.VolaPwd:=pwd.Text;
    // Abilitare o meno la modalita' di test
    Vsms.VolaTestMode:=false;

    Sms:= TSms.Create();
    Sms.SenderPhone:='io';
    // IL DESTINATARIO DEVE ESSERE DELLA FORMA
    // 39 <pref> <numero>
    // esempio 393471234567
    // E' possibile specificare piu' destinatari per lo stesso messaggio
    // separandoli dal carattere , (virgola)
    // Es: 393471234567,393201234567
    Sms.DestPhone:=dest.Text;
    Sms.Msg:=msg.Text;
    // per invii immediati non occorre valorizzare il campo DateTime
    // Altrimenti valorizzarlo con la data e ora di quando si vuole
    // venga recapitato il messaggio
    //Sms.DateTime:= Now;


    CmdResponse:= VSms.SendSms(Sms);
    // Codici di risposta:
    // 01 comando eseguito con successo
    // 99 Username o password errata
    // 98 Parametri di invio non corretti
    // 00 errore di comunicazione con il server

    if CmdResponse.Code='01' then
    begin
      if CmdREsponse.SentNumErr=0 then
        ShowMessage('Il messaggio e'' stato correttamente inoltrato al gw di Vola')
      else
        ShowMessage('Attenzione il messaggio non e'' stato inoltrato.')
    end
    else if CmdResponse.Code='99' then  ShowMessage('Attenzione: username o password errata.')
    else ShowMessage('Attenzione: Codice di errore: ' + CmdResponse.Code + ',' + CmdResponse.ErrMsg);

end;

procedure TForm1.Button2Click(Sender: TObject);
Var
 CmdResponse: TSmsResponse;
 i: Integer;
 Date: String;
begin
    Vsms.VolaUser:=usr.Text;
    Vsms.VolaPwd:=pwd.Text;
    // Impostanfo il test mode a true il server restituisce alcuni sms fittizi
    Vsms.VolaTestMode:=true;

    CmdResponse:=VSms.GetIncomingSms;
    if Length(CmdResponse.SmsIncoming) > 0 then
    SmsList.Items.Clear;
    begin
      for i:=0 to Length(CmdResponse.SmsIncoming)-1 do
      begin
        DateTimeToString(Date, 'yyyy-mm-dd hh:nn', CmdResponse.SmsIncoming[i].DateTime);
        //SmsList.Items.Add(Date);
        //SmsList.Items.Add(CmdResponse.SmsIncoming[i].SenderPhone);
        //SmsList.Items.Add(CmdResponse.SmsIncoming[i].Msg);
        SmsList.Items.Add(Date+#9+CmdResponse.SmsIncoming[i].SenderPhone+#9+CmdResponse.SmsIncoming[i].Msg);
      end;
      SendMessage(SmsList.Handle, LB_SETHORIZONTALEXTENT, 350, 0);
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    Vsms.VolaUser:=usr.Text;
    Vsms.VolaPwd:=pwd.Text;
    // La funzione GetCredit resituisce -1 se fallisce per qualsiasi motivo
    Credito.Text:=IntToStr(VSms.GetCredit);
end;

end.
